'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_User.bas                                                    !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Anwendung:         AT_Test                                                             !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'



$regfile = "m2561def.dat"                                   ' specify the used micro






'##################################################
'# Zuordunungsliste
'##################################################

Beeper Alias Do07                                           'Beeper
Wasserpumpe Alias Do06                                      'Relais 7 Klemme 2/3
Heizungspumpe Alias Do05                                    'Relais 6 Klemme 12/7
Brenner Alias Do04                                          'Relais 5 Klemme 12/8
Do_res03 Alias Do03
Do_res02 Alias Do02
Do_res01 Alias Do01
Relais Alias Do00


Di_res07 Alias Di07
Di_res06 Alias Di06
Di_res05 Alias Di05
Di_res04 Alias Di04
Eingang4 Alias Di03
Eingang3 Alias Di02
Eingang2 Alias Di01
Eingang1 Alias Di00


Ai_res07 Alias Ai07
Ai_res06 Alias Ai06
Ai_res05 Alias Ai05
Ai_res04 Alias Ai04
Ai_res03 Alias Ai03
Ai_res02 Alias Ai02
Ai_res01 Alias Ai01
Ai_res00 Alias Ai00



'###################################################
'Funktionen definieren
'###################################################

Declare Sub Usercycle()

Declare Sub Test_ausgaenge()
Declare Sub Test_keyboard()
Declare Sub Test_lcd()
Declare Sub Test_eingaenge
Declare Sub Test_wahlschalter()

'###################################################

Dim Step As Integer

Dim Temp1 As Integer

Dim Kb As Byte





Goto Enduser


'##################################
'User Program
'##################################

Sub Usercycle()

'Test_eingaenge
'Test_ausgaenge
Test_keyboard

'Test_wahlschalter

'Test_lcd

End Sub






Sub Test_ausgaenge()

Select Case Step

   Case 0:

    Waitms 2000

   Wasserpumpe = 1
   Beeper = On

   Step = 1

   Lcdtext = "Rel7-Wasserpumpe"
    Clear_lcd 2
   Show_lcd 2 , 1 , Lcdtext


   Case 1:

    Waitms 2000

   Wasserpumpe = 0
   Beeper = Off

   Lcdtext = "Aus"
    Clear_lcd 2
   Show_lcd 2 , 5 , Lcdtext

   Step = 2


    Case 2:

    Waitms 2000

   Wasserpumpe = 1

   Lcdtext = "Rel7-Wasserpumpe"
    Clear_lcd 2
   Show_lcd 2 , 1 , Lcdtext

   Step = 3


    Case 3:

        Waitms 2000

   Wasserpumpe = 0

   Lcdtext = "Aus"
    Clear_lcd 2
   Show_lcd 2 , 5 , Lcdtext

   Step = 0


  End Select

End Sub


Sub Test_keyboard()





  '1. Reihe
  '##########

  #if 0
  If Keyb = Asc( "1") Then
    Wasserpumpe = 1

    If Kb <> Keyb Then
    Kb = Keyb
    Lcdtext = "Rel6-Heizungspumpe"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If
  #endif

   If Keyb = Asc( "2") Then
    Heizungspumpe = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel6-Heizungspumpe"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If

 If Keyb = Asc( "3") Then
    Brenner = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel6-BHeizungspumpe"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If


 '2. Reihe
 '#########

 If Keyb = Asc( "4") Then
    Wasserpumpe = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel5-Brenner"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If

  If Keyb = Asc( "5") Then
    Heizungspumpe = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel5-Brenner"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If

  If Keyb = Asc( "6") Then
    Brenner = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel5-Brenner"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If

  '3. Reihe
  '########

  If Keyb = Asc( "7") Then
    Wasserpumpe = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel7-Wasserpumpe"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If


  If Keyb = Asc( "8") Then
    Heizungspumpe = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel7-Wasserpumpe"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If


 If Keyb = Asc( "9") Then
    Brenner = 1
  '  Beeper = On
  '  Relais = On

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel7-Wasserpumpe"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If


  '#4. Reihe
  '##########

  If Keyb = Asc( "*") Then
    Wasserpumpe = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel5-Brenner"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If

  If Keyb = Asc( "#") Then
    Brenner = 1

     If Kb <> Keyb Then
    Kb = Keyb
   Lcdtext = "Rel5-Brenner"
    Clear_lcd 2
    Show_lcd 2 , 1 , Lcdtext
    End If

  End If


  If Keyb = Asc( "0") Then
    Wasserpumpe = 0
    Heizungspumpe = 0
    Brenner = 0
    Beeper = Off
    Relais = Off

    If Kb <> Keyb Then
    Kb = Keyb
    Lcdtext = "Aus"
    Clear_lcd 2
    Show_lcd 2 , 6 , Lcdtext
    End If

  End If


End Sub



Sub Test_lcd()
 Dim I As Integer

 I = I + 1

 'Enable Interrupts
 'Disable Interrupts

 'Config Date = Mdy , Separator = .
 'Config Clock = Soft
 'Date$ = "28.01.10"
 'Time$ = "12:30:59"

' Clear_lcd 1
' Clear_lcd 2


  Clear_lcd 2
 Lcdtext = "Time$"
 Show_lcd 1 , 1 , Lcdtext
 Lcdtext = "Main Loop: " + Str(i)
 Show_lcd 2 , 1 , Lcdtext


 Locate 2 , 6
 Cursor On                                                  'show cursor


 Waitms 500


 Cursor Off
End Sub



Sub Test_eingaenge()

If Eingang1 = 1 Then
  Brenner = 1
End If
If Eingang2 = 1 Then
  Heizungspumpe = 1
End If
If Eingang3 = 1 Then
  Brenner = 1
End If
If Eingang4 = 1 Then
  Heizungspumpe = 1
End If


End Sub



Sub Test_wahlschalter()

If Wahlschalter = 1 Then
  Brenner = 1
End If
If Wahlschalter = 2 Then
  Heizungspumpe = 1
End If
If Wahlschalter = 3 Then
  Wasserpumpe = 1
End If
If Wahlschalter = 4 Then
  Brenner = 0
  Heizungspumpe = 0
  Wasserpumpe = 0

End If

If Wahlschalter = 5 Then
  Brenner = 1
End If
If Wahlschalter = 6 Then
  Heizungspumpe = 1
End If
If Wahlschalter = 7 Then
  Wasserpumpe = 1
End If
If Wahlschalter = 8 Then
  Brenner = 0
  Heizungspumpe = 0
  Wasserpumpe = 0

End If


If Wahlschalter = 9 Then
  Brenner = 1
End If
If Wahlschalter = 10 Then
  Heizungspumpe = 1
End If
If Wahlschalter = 11 Then
  Wasserpumpe = 1
End If
If Wahlschalter = 12 Then
  Brenner = 0
  Heizungspumpe = 0
  Wasserpumpe = 0

End If



End Sub












'####################
'Modul Endekennung
'####################
Enduser: